-- PFT trace decoder
-- 2nd version
-- Decode trace generated by PTM and recovered in the PL through TPIU (Trace Port Interface Unit)

library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;

use std.textio.all;
use std.env.all;

entity testbench_multiple_regions is
end entity;

architecture test1 of testbench_multiple_regions is
signal data_in : std_logic_vector(7 downto 0) := (others => '0');
signal clk : std_logic := '0';
signal reset : std_logic;
signal enable, fifo_overflow : std_logic;
signal pc  : std_logic_vector(31 downto 0) := (others => '0');
signal w_en, w_ctxt_en, rd_en : std_logic;
signal waypoint_address, context_id: std_logic_vector(31 downto 0);
signal waypoint_address_en : std_logic;
signal count : std_logic_vector(9 downto 0);
signal pc_changed : boolean;  

type array_slv is array(natural range<>) of std_logic_vector(31 downto 0);
constant expected_result_pc : array_slv := (
X"00010384",
X"00010340",
X"b6f90838",
X"000104dc",
X"0001036c",
X"00010340",
X"b6f90838",
X"000104ec",
X"00010524",
X"00010360",
X"00010340",
X"b6f90838",
X"00010538",
X"00010550",
X"00010378",
X"00010340",
X"b6f90838",
X"00010564",
X"0001039c",
X"00010340",
X"b6f90838",
X"0001056c",
X"00010354",
X"00010340",
X"b6f90838",
X"00010580",
X"b6e56cf8",
X"b6e56c00",
X"b6e0ffc0",
X"b6e07b58"
);


-- functions declaration

    function CONV (X :STD_LOGIC) return BOOLEAN is
    constant XMAP :BOOLEAN :=FALSE;
  begin
    case X is
      when '0' | 'L' => return FALSE;
      when '1' | 'H' => return TRUE;
      when others => return XMAP;
    end case;
  end CONV;

    -- or_reduce
    function or_reduce(vector : std_logic_vector) return boolean is
    variable result : std_logic := '0';
    begin
        for i in vector'range loop
            result := result or vector(i);
        end loop; 
        return CONV(result);
    end function;


-- converts an integer into a character
   -- for 0 to 9 the obvious mapping is used, higher
   -- values are mapped to the characters A-Z
   -- (this is usefull for systems with base > 10)
   -- (adapted from Steve Vogwell's posting in comp.lang.vhdl)


   function chr(int: integer) return character is
    variable c: character;
   begin
        case int is
          when  0 => c := '0';
          when  1 => c := '1';
          when  2 => c := '2';
          when  3 => c := '3';
          when  4 => c := '4';
          when  5 => c := '5';
          when  6 => c := '6';
          when  7 => c := '7';
          when  8 => c := '8';
          when  9 => c := '9';
          when 10 => c := 'A';
          when 11 => c := 'B';
          when 12 => c := 'C';
          when 13 => c := 'D';
          when 14 => c := 'E';
          when 15 => c := 'F';
          when 16 => c := 'G';
          when 17 => c := 'H';
          when 18 => c := 'I';
          when 19 => c := 'J';
          when 20 => c := 'K';
          when 21 => c := 'L';
          when 22 => c := 'M';
          when 23 => c := 'N';
          when 24 => c := 'O';
          when 25 => c := 'P';
          when 26 => c := 'Q';
          when 27 => c := 'R';
          when 28 => c := 'S';
          when 29 => c := 'T';
          when 30 => c := 'U';
          when 31 => c := 'V';
          when 32 => c := 'W';
          when 33 => c := 'X';
          when 34 => c := 'Y';
          when 35 => c := 'Z';
          when others => c := '?';
        end case;
        return c;
    end chr;

   -- convert integer to string using specified base
   -- (adapted from Steve Vogwell's posting in comp.lang.vhdl)

   function str(int: integer; base: integer) return string is

    variable temp:      string(1 to 10);
    variable num:       integer;
    variable abs_int:   integer;
    variable len:       integer := 1;
    variable power:     integer := 1;

   begin

    -- bug fix for negative numbers
    abs_int := abs(int);

    num     := abs_int;

    while num >= base loop                     -- Determine how many
      len := len + 1;                          -- characters required
      num := num / base;                       -- to represent the
    end loop ;                                 -- number.

    for i in len downto 1 loop                 -- Convert the number to
      temp(i) := chr(abs_int/power mod base);  -- a string starting
      power := power * base;                   -- with the right hand
    end loop ;                                 -- side.

    -- return result and add sign if required
    if int < 0 then
       return '-'& temp(1 to len);
     else
       return temp(1 to len);
    end if;

   end str;

  -- convert integer to string, using base 10
  function str(int: integer) return string is

   begin

    return str(int, 10) ;

   end str;


-- converts std_logic into a character

   function chr(sl: std_logic) return character is
    variable c: character;
    begin
      case sl is
         when 'U' => c:= 'U';
         when 'X' => c:= 'X';
         when '0' => c:= '0';
         when '1' => c:= '1';
         when 'Z' => c:= 'Z';
         when 'W' => c:= 'W';
         when 'L' => c:= 'L';
         when 'H' => c:= 'H';
         when '-' => c:= '-';
      end case;
    return c;
end chr;


function str(slv: std_logic_vector) return string is
     variable result : string (1 to slv'length);
     variable r : integer;
   begin
     r := 1;
     for i in slv'range loop
        result(r) := chr(slv(i));
        r := r + 1;
     end loop;
     return result;
   end str;


-- component declaration
component decodeur_traces
generic (ctxtid_bits : std_logic_vector(1 downto 0) := "00");
port(
clk, reset, enable : in std_logic;
trace_data : in std_logic_vector(7 downto 0);
pc : out std_logic_vector(31 downto 0);
w_en, w_ctxt_en, fifo_overflow : out std_logic;
waypoint_address, context_id : out std_logic_vector(31 downto 0);
waypoint_address_en : out std_logic
);
end component;

begin
u1: decodeur_traces
    generic map(ctxtid_bits => "00") 
    port map (
	clk,reset, enable, data_in, pc, w_en, w_ctxt_en, fifo_overflow, waypoint_address, context_id, waypoint_address_en
	);

clock_tic: process
begin
--wait for 1 ns;
loop
clk <= '1'; wait for 5 ns;
clk <= '0'; wait for 5 ns;
end loop;
end process;
--clk <= not clk after 5 ns;

input_changes : process
begin
count <= "0000000000" after 0 ns,
"0000000001" after 40 ns,
"0010000000" after 100 ns;

reset <= '1' after 0 ns, 
         '0' after 170 ns;
enable <= '0' after 0 ns,
          '1' after 170 ns; 
data_in <= 
X"00" after 170 ns,
X"00" after 180 ns,
X"00" after 190 ns,
X"00" after 200 ns,
X"00" after 210 ns,
X"80" after 220 ns,
X"08" after 230 ns,
X"84" after 240 ns,
X"03" after 250 ns,
X"01" after 260 ns,
X"00" after 270 ns,
X"21" after 280 ns,
X"21" after 290 ns,
X"9d" after 300 ns,
X"88" after 310 ns,
X"f2" after 320 ns,
X"db" after 330 ns,
X"0d" after 340 ns,
X"08" after 350 ns,
X"dc" after 360 ns,
X"04" after 370 ns,
X"01" after 380 ns,
X"00" after 390 ns,
X"21" after 400 ns,
X"b7" after 410 ns,
X"03" after 420 ns,
X"21" after 430 ns,
X"9d" after 440 ns,
X"88" after 450 ns,
X"f2" after 460 ns,
X"db" after 470 ns,
X"0d" after 480 ns,
X"08" after 490 ns,
X"ec" after 500 ns,
X"04" after 510 ns,
X"01" after 520 ns,
X"00" after 530 ns,
X"21" after 540 ns,
X"93" after 550 ns,
X"05" after 560 ns,
X"b1" after 570 ns,
X"03" after 580 ns,
X"21" after 590 ns,
X"9d" after 600 ns,
X"88" after 610 ns,
X"f2" after 620 ns,
X"db" after 630 ns,
X"0d" after 640 ns,
X"08" after 650 ns,
X"38" after 660 ns,
X"05" after 670 ns,
X"01" after 680 ns,
X"00" after 690 ns,
X"21" after 700 ns,
X"29" after 710 ns,
X"bd" after 720 ns,
X"03" after 730 ns,
X"21" after 740 ns,
X"9d" after 750 ns,
X"88" after 760 ns,
X"f2" after 770 ns,
X"db" after 780 ns,
X"0d" after 790 ns,
X"08" after 800 ns,
X"64" after 810 ns,
X"05" after 820 ns,
X"01" after 830 ns,
X"00" after 840 ns,
X"21" after 850 ns,
X"cf" after 860 ns,
X"03" after 870 ns,
X"21" after 880 ns,
X"9d" after 890 ns,
X"88" after 900 ns,
X"f2" after 910 ns,
X"db" after 920 ns,
X"0d" after 930 ns,
X"08" after 940 ns,
X"6c" after 950 ns,
X"05" after 960 ns,
X"01" after 970 ns,
X"00" after 980 ns,
X"21" after 990 ns,
X"ab" after 1000 ns,
X"03" after 1010 ns,
X"21" after 1020 ns,
X"9d" after 1030 ns,
X"88" after 1040 ns,
X"f2" after 1050 ns,
X"db" after 1060 ns,
X"0d" after 1070 ns,
X"08" after 1080 ns,
X"80" after 1090 ns,
X"05" after 1100 ns,
X"01" after 1110 ns,
X"00" after 1120 ns,
X"21" after 1130 ns,
X"fd" after 1140 ns,
X"ec" after 1150 ns,
X"ca" after 1160 ns,
X"db" after 1170 ns,
X"0d" after 1180 ns,
X"01" after 1190 ns,
X"00" after 1200 ns,
X"00" after 1210 ns,
X"00" after 1220 ns,
X"00" after 1230 ns,
X"00" after 1240 ns,
X"00" after 1250 ns,
X"00" after 1260 ns,
X"00" after 1270 ns,
X"00" after 1280 ns,
X"00" after 1290 ns,
X"00" after 1300 ns,
X"00" after 1310 ns,
X"00" after 1320 ns,
X"00" after 1330 ns,
X"00" after 1340 ns,
X"00" after 1350 ns,
X"00" after 1360 ns,
X"00" after 1370 ns,
X"00" after 1380 ns,
X"00" after 1390 ns,
X"00" after 1400 ns,
X"00" after 1410 ns,
X"00" after 1420 ns,
X"00" after 1430 ns,
X"00" after 1440 ns
;

wait;
end process;

pc_changed <= or_reduce(pc); 

-- The check process fails not because of an error 
-- It fails because it detects only raising_edge and when there are multiple '1's, it cannot follow ! 
Check_pc_process: process
variable log_line : line;
begin    
    for i in expected_result_pc'range loop
        wait until rising_edge(w_en) or w_en = '1'; 
        write(log_line,
            "pc (i): " & str(i) &
            ", check: " & str(pc) &
            ", expected: " & str(expected_result_pc(i))
            );
        writeline(output, log_line); 
        assert pc = expected_result_pc(i); 
    end loop;

    report "End of Simulation (PC). All tests passed."; 
    finish; 
end process; 


end test1;
